

// this must be first - winsock issues
#include "vsds.h"

#include "dataio.h"
#include "timer.h"


int counter = SDS_FIRST_PLATFORM_ID;


/* **************************************************************
************************************************************** */
sds_data::sds_data(basic_platform *x) : platform_data(x) {

}


/* **************************************************************
************************************************************** */
void sds_data::label(dbl_llist_manager *label_manager) {


}


/* **************************************************************
************************************************************** */
void sds_data::update(double *machine_time) {

   vector3d diff;
   vector3d pyr;
   
   diff[0] = eu_packet.pos.xyz[0] - parent->plat_clone.pos[0];   
   diff[1] = eu_packet.pos.xyz[1] - parent->plat_clone.pos[2];   
   diff[2] = eu_packet.pos.xyz[2] + parent->plat_clone.pos[1];   

   pyr[0] = parent->plat_clone.rpy[1];
   pyr[1] = parent->plat_clone.rpy[2];
   pyr[2] = parent->plat_clone.rpy[0];

   if (dotproduct3(diff, diff) > 1.0 || fabs(eu_packet.orient.pyr[0]-pyr[0]) > 0.01 || fabs(eu_packet.orient.pyr[1]-pyr[1]) > 0.01  || fabs(eu_packet.orient.pyr[2]-pyr[2]) > 0.01) {
      eu_packet.pos.xyz[0] = parent->plat_clone.pos[0];
      eu_packet.pos.xyz[1] = parent->plat_clone.pos[2];
      eu_packet.pos.xyz[2] = -parent->plat_clone.pos[1];

      copyarray3(eu_packet.orient.pyr, (float)pyr);

      flags |= SDS_FLAG_UPDATE;
   }
   
}


/* **************************************************************
************************************************************** */
void sds_data::render(iface *isim) {

   buffer_type buffer;
   sfile sbuffer;
   
   if (flags & SDS_FLAG_UPDATE) {

      sbuffer.dest();
      sbuffer.sput_int(eu_packet.header.type);
      sbuffer.sput_int(eu_packet.header.size);
      sbuffer.sput_int(eu_packet.id);
      sbuffer.sput_int(eu_packet.type);

      sbuffer.sput_double(eu_packet.pos.xyz[0]);
      sbuffer.sput_double(eu_packet.pos.xyz[1]);
      sbuffer.sput_double(eu_packet.pos.xyz[2]);
      sbuffer.sput_float(eu_packet.orient.pyr[0]);
      sbuffer.sput_float(eu_packet.orient.pyr[1]);
      sbuffer.sput_float(eu_packet.orient.pyr[2]);

      sbuffer.sput_int(eu_packet.padd);

      buffer.buffercpy((char *)sbuffer.data, sbuffer.vsize);
      pcigiface.send_message(&buffer);
      flags &= ~SDS_FLAG_UPDATE;
   }
   
}


/* **************************************************************
************************************************************** */
int sds_data::perform(iface *isim, int task, void *data) {

   buffer_type buffer;
   sfile sbuffer;

   switch (task) {
      case PERFORM_PLATFORM_DEACTIVATE:
         sbuffer.dest();
         sbuffer.sput_int(eu_packet.header.type);
         sbuffer.sput_int(eu_packet.header.size);
         sbuffer.sput_int(eu_packet.id);
         sbuffer.sput_int(0);

         buffer.buffercpy((char *)sbuffer.data, sbuffer.vsize);
         pcigiface.send_message(&buffer);
         return 1;

      default:
         break;
   }

   return platform_data::perform(isim, task, data);
}


/* **************************************************************
************************************************************** */
int sds_data::init(iface *isim, correlate *basis, symbol_correlation_type *str) {

   static int counter = 0;
   sfile sbuffer;
   buffer_type buffer;

   eu_packet.id = counter++;
   eu_packet.type = str->sym_sds;

   eu_packet.pos.xyz[0] = 0;
   eu_packet.pos.xyz[1] = 0;
   eu_packet.pos.xyz[2] = 0;

   eu_packet.orient.pyr[0] = 0;
   eu_packet.orient.pyr[1] = 0;
   eu_packet.orient.pyr[2] = 0;

   flags = SDS_FLAG_UPDATE;

   render(isim);

   if (!(parent->platform_flag & PLATFORM_FLAG_FLY)) {
      SLEEP(0.01);

      sbuffer.dest();
      sbuffer.sput_int(PCIG_TYPE_STATUS_UPDATE);
      sbuffer.sput_int(PCIG_SIZE_STATUS_UPDATE);
      sbuffer.sput_int(eu_packet.id);
      sbuffer.sput_int(eu_packet.type);
      sbuffer.sput_int(PCIG_STATUS_CLAMP);
      sbuffer.sput_float(1.0f);
      sbuffer.sput_float(1.0f);
      sbuffer.sput_float(1.0f);
      sbuffer.sput_double(eu_packet.pos.xyz[0]);
      sbuffer.sput_double(eu_packet.pos.xyz[1]);
      sbuffer.sput_double(eu_packet.pos.xyz[2]);
      sbuffer.sput_float(eu_packet.orient.pyr[0]);
      sbuffer.sput_float(eu_packet.orient.pyr[1]);
      sbuffer.sput_float(eu_packet.orient.pyr[2]);
      sbuffer.sput_int(eu_packet.padd);

      buffer.buffercpy((char *)sbuffer.data, sbuffer.vsize);
      pcigiface.send_message(&buffer);
   }

   return 1;
}
